import _Object$keys from 'babel-runtime/core-js/object/keys';
import _typeof from 'babel-runtime/helpers/typeof';
import invariant from 'invariant';
import { Observable } from 'rxjs';
import isObservable from 'fluorine-lib/lib/util/isObservable';

export default function combineStores(stores) {
  invariant((typeof stores === 'undefined' ? 'undefined' : _typeof(stores)) === 'object', 'combineStores: `stores` is expected to be an object containing Observables.');

  var keys = _Object$keys(stores);

  function reduceStates() {
    var size = arguments.length;
    var state = {};

    for (var index = 0; index < size; index++) {
      var key = keys[index];
      state[key] = arguments[index];
    }

    return state;
  }

  return Observable.combineLatest.apply(Observable, keys.map(function (key) {
    var store = stores[key];

    invariant(isObservable(store), 'combineStores: `stores` is expected to contain Observables only.');

    return store;
  }).concat([reduceStates]));
}