'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = toMap;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function toMap(value) {
  (0, _invariant2.default)(_immutable.Iterable.isKeyed(value), 'toMap: `value` is expected to be a keyed iterable.');

  var item = _immutable.Map.isMap(value) ? value : new _immutable.Map(value);
  (0, _invariant2.default)(item.has('id') && typeof item.get('id') === 'string', 'toMap: `value` is expected to contain an `id`.');

  return item;
}